# - Try to find Octave (development)
# Once done this will define
#  LIBXML2_FOUND - System has LibXml2
#  OCTAVE_INCLUDE_DIRS - The LibXml2 include directories
#  OCTAVE_LIBRARIES - The libraries needed to use LibXml2
##  LIBXML2_DEFINITIONS - Compiler switches required for using LibXml2

# 2016-06-19: update inspired by:
#    https://github.com/aurelw/beholder/blob/master/cmake_modules/FindOctave.cmake


find_package(PkgConfig)
pkg_check_modules(PC_OCTAVE QUIET liboctave)
#set(LIBXML2_DEFINITIONS ${PC_LIBXML_CFLAGS_OTHER})

execute_process(COMMAND octave-config -p OCTLIBDIR OUTPUT_VARIABLE OCTAVE_LIBDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
execute_process(COMMAND octave-config -p OCTINCLUDEDIR OUTPUT_VARIABLE OCTAVE_INCDIR OUTPUT_STRIP_TRAILING_WHITESPACE)

find_path(OCTAVE_INCLUDE_DIR octave/oct.h PATHS ${OCTAVE_INCDIR} ${OCTAVE_INCDIR}/.. )

find_library(OCTAVE_LIBRARY octave PATHS ${OCTAVE_LIBDIR} )
find_library(OCTINTERP_LIBRARY octinterp PATHS ${OCTAVE_LIBDIR} )

get_filename_component(OCTAVE_LIBDIR ${OCTAVE_LIBRARY} PATH)

set(OCTAVE_LIBRARIES ${OCTAVE_LIBRARY} ${OCTINTERP_LIBRARY})
set(OCTAVE_INCLUDE_DIRS ${OCTAVE_INCLUDE_DIR} )


include(FindPackageHandleStandardArgs)
# handle the QUIETLY and REQUIRED arguments and set LIBXML2_FOUND to TRUE
# if all listed variables are TRUE
find_package_handle_standard_args(Octave  DEFAULT_MSG
                                  OCTAVE_LIBRARY OCTAVE_INCLUDE_DIR)

mark_as_advanced(
  OCTAVE_INCLUDE_DIR 
  OCTAVE_LIBRARY 
  OCTINTERP_LIBRARY
)

